var server = {};

server.URL_TYPE = 3;      //URL类型   1:局域   2:测试   3:外网

server.LOCAL_URL = "http://192.168.11.28:6161/web/MathGame/";
//server.LOCAL_URL = "http://192.168.0.53:88/web/MathGame/";  
server.TEST_URL = "http://192.168.0.89:6161/handler.ashx";
server.WEB_URL = "https://api.whtdlx.com/web/mathgame/";

server.lessonData = [];
server.curLessonId = 0;        //上次玩的地图

//测试数据
server.testData =
    {
        "total":
        {
            "currentlessoncode": "222"
        },
        "lessonlist":
            [
            ]
    };



// server.

//服务器
server.getUrl = function(){
    if(server.URL_TYPE == 1){
        //内网
        return server.LOCAL_URL;
    }else if(server.URL_TYPE == 2){
        //测试网
        return server.TEST_URL;
    }else if(server.URL_TYPE == 3){
        //外网
        return server.WEB_URL;
    }
}

//游戏退出时的联网
server.addMathGameRecord = function(_gameid,_star, _time, _func){
    var data = {};
    data["cocosgamecode"] = _gameid;              //游戏编码
    data["gametimestamp"] = game.store.get("timestamp");              //用户关联的宝宝编码（主账号）

    data["time"] = _time;              //时间
    data["star"] = _star;              //星星数

    data["userid"] = game.store.get("userid");              //用户编码
    data["babyid"] = game.store.get("babyid");              //用户关联的宝宝编码（主账号）
    data["bookid"] = game.store.get("bookid");              //教材编码
    data["platform"] = game.store.get("platform");          //登录平台（ios或ANDROID）
    data["version"] = game.store.get("version");            //App版本号
    data["udid"] = game.store.get("udid");                  //设备唯一编码
    data["token"] = game.store.get("token");                //与用户编码对应的口令

    if(_star != 0 || _time != 0){
        ajaxRequest({
            url:server.getUrl() + "addMathGameRecord.ashx",
            data:data,
            dataType:"text",
            error:function () {
                //alert("调用出错！");
                _func();
            },
            success:function (obj) {
                _func();
            },
            type:"POST"
        });
    }
};


/**
 * 取教材所有游戏getBookMathGame
 * @param _cb 回调
 *
 * 进入地图的时的联网
 */
server.getBookMathGameData = function(_needServer, _cb2){

    var data = {};
//    data["userid"] = game.store.get("userid");              //用户编码
//    data["babyid"] = game.store.get("babyid");              //用户关联的宝宝编码（主账号）
//    data["bookid"] = game.store.get("bookid");              //教材编码
//    data["platform"] = game.store.get("platform");          //登录平台（ios或ANDROID）
//    data["version"] = game.store.get("version");            //App版本号
//    data["udid"] = game.store.get("udid");                  //设备唯一编码
//    data["token"] = game.store.get("token");                //与用户编码对应的口令

    //测试数据

    //?userid=2191&babyid=2190&bookid=15240&platform=ios&agecode=1&udid=498803B2886A4A2E80C038A963BBDB4A&version=2.2.3&token=17242FEDEA8C4AD6BBA58BC54F2E435B
    //?userid=790336&babyid=790338&platform=pc&version=3.0.0&udid=863455032199178&token=F4945C95190A430BB2503AC362E4FAA4&timestamp=1503537265797&bookid=1840&inapp=2&gameid=8692
    data["userid"] = 2191;              //用户编码
    data["babyid"] = 2190;              //用户关联的宝宝编码（主账号）
    data["bookid"] = 15239;              //教材编码
    data["platform"] = "android";          //登录平台（ios或ANDROID）
    data["version"] = "2.2.3";            //App版本号
    data["udid"] = "498803B2886A4A2E80C038A963BBDB4A";       //设备唯一编码
    data["token"] = "17242FEDEA8C4AD6BBA58BC54F2E435B";      //与用户编码对应的口令

    var url;
    if(_needServer){
        url = server.getUrl() + "getBookMathGame.ashx";
    }else{
        url = server.getUrl() + "getGameSetting.ashx";
    }

    ajaxRequest({
        url:url,
        data:data,
        dataType:"text",
        error:function () {
            //alert("调用出错！");
            // _cb();

//            var data = server.testData;
//            server.initBookMathGameData(data, _cb2);
        },
        success:function (obj) {
            var jsonData = JSON.parse(obj);
            server.gamesetting = jsonData["data"]["gamesetting"];

            if(_needServer){    //第一次登陆岛屿
                var data = jsonData["data"];
                server.initBookMathGameData(data, _cb2);
            }else{  //从游戏返回到岛屿里面
                server.lessonData = game.store.get("lessondata");
                server.curLessonId = game.store.get("currentlessoncode");
                _cb2();
            }
        },
        type:"POST"});
};

server.initBookMathGameData = function(_data, _cb2){

    server.lessonData = [];
    server.curLessonId = _data.total.currentlessoncode;

    var i;
    for(i = 0;i<_data.lessonlist.length;i++){
        var d = _data.lessonlist[i];
        var lesson = {};
        lesson["index"] = i;
        lesson["lessonid"] = d["lessonid"];

        var gameScore = 0;
        for(var j = 0;j<d.gamelist.length;j++){
            var p = d.gamelist[j];
            gameScore+=p.star;
        }
        //满分是三分
        var score = gameScore/d.gamelist.length/5;
        if(score === 1){
            score = 3;
        }else if(score >= 0.5){
            score = 2;
        }else if(score > 0){
            score = 1;
        }else{
            score = 0;
        }
        lesson["score"] = score;

        lesson["gamelist"] = d["gamelist"];

        server.lessonData.push(lesson);
    }

    game.store.set("lessondata", server.lessonData);
    game.store.set("currentlessoncode", server.curLessonId);
    _cb2();
};

server.getIndexByLessonId = function(_lessonid){
    var i;
    for(i = 0;i<server.lessonData.length;i++){
        var o = server.lessonData[i];
        if(o.lessonid == _lessonid){
            return o.index;
        }
    }
};

server.updateLessonData = function(_lessonid, _gameid, _star, _time){
    var i;
    var j;
    for(i = 0;i<server.lessonData.length;i++){
        var o = server.lessonData[i];
        if(o.lessonid == _lessonid){
            var gameScore = 0;
            for(j = 0;j<o.gamelist.length;j++){
                var p = o.gamelist[j];
                if(p.gameid == _gameid){
                    p.star = _star;
                    p.time = _time;
                }
                gameScore+=p.star;
            }

            //满分是三分
            var score = gameScore/o.gamelist.length/5;
            if(score === 1){
                score = 3;
            }else if(score >= 0.5){
                score = 2;
            }else if(score > 0){
                score = 1;
            }else{
                score = 0;
            }
            server.lessonData[i].score = score;
        }
    }
    game.store.set("lessondata", server.lessonData);
};

//发送家长管理的设置数据
server.sendParentSettingsData = function(sleeptime, expiredtime, _func){
    var data = {};
    data["userid"] = game.store.get("userid");              //用户编码
    data["babyid"] = game.store.get("babyid");              //用户关联的宝宝编码（主账号）
    data["sleeptime"] = sleeptime;                           //休息提醒时间
    data["expiredtime"] = expiredtime;                       //休息提醒时间
    data["platform"] = game.store.get("platform");          //登录平台（ios或ANDROID）
    data["version"] = game.store.get("version");            //App版本号
    data["udid"] = game.store.get("udid");                  //设备唯一编码
    data["token"] = game.store.get("token");                //与用户编码对应的口令

    ajaxRequest({
        url:server.getUrl() + "gameSetting.ashx",
        data:data,
        dataType:"text",
        error:function () {
            //alert("调用出错！");
        },
        success:function (obj) {
            var jsonData = JSON.parse(obj);
            _func(jsonData);
        },
        type:"POST"
    });
};

server.addMathGameInOutRecord = function(_gameid, _actiontype, _func){
    var data = {};
    data["cocosgamecode"] = _gameid;              // 游戏编码
    data["actiontype"] = _actiontype;                  // 动作类型（1:进入数学游戏 2:强制退出数学游戏）
    if(_actiontype == 2){
        data["recordid"] = server.recordid;                       // 记录编码(非正常退出游戏时传入，进入游戏时传空)
    }

    data["userid"] = game.store.get("userid");              //用户编码
    data["babyid"] = game.store.get("babyid");              //用户关联的宝宝编码（主账号）
    data["bookid"] = game.store.get("bookid");              //教材编码
    data["platform"] = game.store.get("platform");          //登录平台（ios或ANDROID）
    data["version"] = game.store.get("version");            //App版本号
    data["udid"] = game.store.get("udid");                  //设备唯一编码
    data["token"] = game.store.get("token");                //与用户编码对应的口令

    ajaxRequest({
        url:server.getUrl() + "addMathGameInOutRecord.ashx",
        data:data,
        dataType:"text",
        error:function () {},
        success:function (obj) {
            var jsonData = JSON.parse(obj);
//            d("jsonData")
//            d(jsonData)
            if(_actiontype == 2 && _func){
                _func();
            }else{
                var data = jsonData["msg"];
                server.recordid = data;
            }
        },
        type:"POST"
    });
};


//进入游戏时调用接口
server.addMathGameTaskRecord = function(_func){
    var data = {};

    data["userid"] = game.store.get("userid");              //用户编码
    data["babyid"] = game.store.get("babyid");              //用户关联的宝宝编码（主账号）
    data["bookid"] = game.store.get("bookid");              //教材编码
    data["platform"] = game.store.get("platform");          //登录平台（ios或ANDROID）
    data["version"] = game.store.get("version");            //App版本号
    data["udid"] = game.store.get("udid");                  //设备唯一编码
    data["token"] = game.store.get("token");                //与用户编码对应的口令
    data["taskid"] = game.store.get("taskid"); 

    ajaxRequest({
        url:server.getUrl() + "addMathGameTaskRecord.ashx",
        data:data,
        dataType:"text",
        error:function () {},
        success:function (obj) {
            var jsonData = JSON.parse(obj);

            if(_actiontype == 2 && _func){
                _func();
            }else{
                var data = jsonData["msg"];
                server.recordid = data;
            }
        },
        type:"POST"
    });
};


//新版测评结束后
server.InsertMathgameEvaluation = function(){

    var data = groupGame.gameEvaluationServerData[groupGame.gameIndex];

    data["userid"] = game.store.get("userid");              //用户编码
    data["babyid"] = game.store.get("babyid");              //用户关联的宝宝编码（主账号）             //教材编码
    data["platform"] = game.store.get("platform");          //登录平台（ios或ANDROID）
    data["version"] = game.store.get("version");            //App版本号
    data["udid"] = game.store.get("udid");                  //设备唯一编码
    data["token"] = game.store.get("token");                //与用户编码对应的口令

    data["passlevel"] = parseInt(game.store.get('lessonid'));
    data["agecode"] = parseInt(game.store.get('age'));
    data["taskid"] = parseInt(game.store.get('taskid'));

    ajaxRequest({
        url:server.getUrl() + "InsertMathgameEvaluation.ashx",
        data:data,
        dataType:"text",
        error:function () {},
        success:function (obj) {
            var jsonData = JSON.parse(obj);
            d("jsonData")
            d(jsonData)
            
        },
        type:"POST"
    });
};

server.setLessonData = function(){

    server.lessonData = game.store.get("lessondata");
    server.curLessonId = game.store.get("currentlessoncode");
};