game.store = {
    set: function(key, data){
        store.set(key, data, true);
    },

    get: function(key){
        if(store.has(key))
            return store.get(key);
        else
            return null;
    },

    remove: function(key){
        store.remove(key);
    },

    clear: function(){
        store.clear();
    },

    has: function(key){
        return store.has(key);
    }
}

//----------------------------------------------------
var d = function(str){
    for(var i=1; i<arguments.length; i++){
        str += " " + arguments[i];
    }
    console.log(str);
}

function ajaxRequest(_ajaxObj)
{
    if(_ajaxObj==null)
        _ajaxObj={
            url:"",
            data:{},
            dataType:"text",
            error:function () {

            },
            success:function (obj) {

            },
            type:"POST"};
    if(typeof(_ajaxObj)=="object")
    {
        if(_ajaxObj["url"]==null)
        {
            _ajaxObj["url"]="";
        }
        if(_ajaxObj["data"]==null)
        {
            _ajaxObj["data"]={};
        }
        if(_ajaxObj["type"]==null)
        {
            _ajaxObj["type"]="POST";
        }
        if(_ajaxObj["dataType"]==null)
        {
            _ajaxObj["dataType"]="text";
        }
        if(_ajaxObj["error"]==null)
        {
            _ajaxObj["error"]=function () {

            };
        }
        if(_ajaxObj["success"]==null)
        {
            _ajaxObj["success"]=function (obj) {

            };
        }
    }

    var request=new XMLHttpRequest();
    var result = "{}";
    request.onreadystatechange=function(){
        if(request.readyState==4){
            if(request.status == 200) {
                result = request.responseText;
                if (_ajaxObj["dataType"] == "json") {
                    result = eval("(" + result + ")");
                }
                _ajaxObj["success"](result);
            }
            else{
                _ajaxObj["error"]();
            }
        }
    }
    if(_ajaxObj["type"]=="POST"){
        var par="";
        for(var attrName in _ajaxObj["data"])
        {
            par+="&"+attrName+"="+_ajaxObj["data"][attrName];
        }
        if(par.length>0)
            par=par.substr(1);
        request.open("POST", _ajaxObj["url"], true);
        request.setRequestHeader('Content-Type','application/x-www-form-urlencoded');
        request.send(par);
    }
    else {
        request.open("GET", _ajaxObj["url"], true);
        request.send(null);
    }
}



//-------------------------------------------
var SU = {
    queryString : function(name)
    {
        if(typeof document === 'undefined') return null;
        var reg = new RegExp("(^|&)"+ name +"=([^&]*)(&|$)");
        var r = window.location.search.substr(1).match(reg);
        if (r!=null) return unescape(r[2]); return null;
    },

    //截取backpage后面的url
    queryStringBackpage : function(name)
    {
        if(typeof document === 'undefined') return null;
        var reg = new RegExp("(^|&)"+ name +"=(.*)(&|$)");
        var r = window.location.search.substr(1).match(reg);
        if (r!=null) return unescape(r[2]); return null;
    }
}


var browser = {
    versions:function(){ 
        var u = navigator.userAgent, app = navigator.appVersion; 
        return {
           trident: u.indexOf('Trident') > -1, //IE内核
           presto: u.indexOf('Presto') > -1, //opera内核
           webKit: u.indexOf('AppleWebKit') > -1, //苹果、谷歌内核
           gecko: u.indexOf('Gecko') > -1 && u.indexOf('KHTML') == -1, //火狐内核
           mobile: !!u.match(/AppleWebKit.*Mobile.*/), //是否为移动终端
           ios: !!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/), //ios终端
           android: u.indexOf('Android') > -1 || u.indexOf('Linux') > -1, //android终端或者uc浏览器
           iPhone: u.indexOf('iPhone') > -1 , //是否为iPhone
           iPad: u.indexOf('iPad') > -1, //是否iPad
        };
    }(),
    language:(navigator.browserLanguage || navigator.language).toLowerCase()
};

//----------------------------------------------
var device = {
    isHtml5:(typeof document !== 'undefined')
};

device.__init = function(){
    if(game.store.has("platform")){
        var __platform = game.store.get("platform");

        device.iosreview = __platform == "iosreview";
        device.ios = __platform == "ios";
        device.android = __platform == "android";
        device.pc = __platform == "pc";
    }else{
        device.ios = false; // (cc.sys.os === cc.sys.OS_IOS || cc.sys.os === cc.sys.OS_OSX)
        device.android = false; // sys.OS_ANDROID
        device.pc = true; // sys.OS_ANDROID
    }
};


//-----------------------------------------------
var display = {}

display.size = {width:1280, height:720}; // cc.view.getFrameSize();  // cc.view.getFrameSize(); cc.director.getWinSize(); cc.winSize;
display.width = display.size.width;
display.height = display.size.height;
display.cx = display.width/2;
display.cy = display.height/2;
display.left = 0;
display.right = display.width;
display.top = display.height;
display.bottom = 0;


display.CENTER        = 0;
display.LEFT_TOP      = 1; 
display.TOP_LEFT      = 1;
display.CENTER_TOP    = 2;
display.TOP_CENTER    = 2;
display.RIGHT_TOP     = 3;
display.TOP_RIGHT     = 3;
display.CENTER_LEFT   = 4;
display.LEFT_CENTER   = 4;
display.CENTER_RIGHT  = 5;
display.RIGHT_CENTER  = 5;
display.BOTTOM_LEFT   = 6;
display.LEFT_BOTTOM   = 6;
display.BOTTOM_RIGHT  = 7;
display.RIGHT_BOTTOM  = 7;
display.BOTTOM_CENTER = 8;
display.CENTER_BOTTOM = 8;

display.ANCHOR_POINTS = [
    cc.p(0.5, 0.5),  // CENTER
    cc.p(0, 1),      // TOP_LEFT
    cc.p(0.5, 1),    // TOP_CENTER
    cc.p(1, 1),      // TOP_RIGHT
    cc.p(0, 0.5),    // CENTER_LEFT
    cc.p(1, 0.5),    // CENTER_RIGHT
    cc.p(0, 0),      // BOTTOM_LEFT
    cc.p(1, 0),      // BOTTOM_RIGHT
    cc.p(0.5, 0)     // BOTTOM_CENTER
];

display.align = function(target, anchorPoint, x, y){
    target.setAnchorPoint(display.ANCHOR_POINTS[anchorPoint]);
    if(utils.isNumber(x) && utils.isNumber(y)){
        target.setPosition(x, y);
    }
};

display.newNode = function(){
    return new cc.Node();
};

display.newSprite = function(filename, x, y){
    var sprite = new cc.Sprite(filename);
    if(x && y){
        sprite.setPosition(x, y);
    }
    return sprite; 
};

display.newScale9Sprite = function(filename, x, y, w, h){
    var sprite = new cc.Scale9Sprite(path);
    sprite.width = w;
    sprite.height = h;
    sprite.x = x;
    sprite.y = y;
    return sprite;
};

display.newGraySprite = function(filename){
    // 得到纹理
    var texture = cc.textureCache.getTextureForKey(filename);
    if (!texture) {
        texture = cc.textureCache.addImage(filename);
    } 

    // 判断运行的平台是不是浏览器
    if (utils.isHtml5) {
        var canvas = document.createElement('canvas'); 
        var image = texture.getHtmlElementObj();

        // 将图片的高宽赋值给画布
        canvas.width = image.width;
        canvas.height = image.height;

        // 获得二维渲染上下文
        if(canvas.getContext) {//为了安全起见，先判断浏览器是否支持canvas
            var context = canvas.getContext("2d");
            context.drawImage(image, 0, 0);//将得到的image图像绘制在canvas对象中
            var canvasData = context.getImageData(0, 0, canvas.width, canvas.height);//返回ImageData对象

            // 填充灰色【读取像素值和实现灰度计算】
            for (var x = 0; x < canvasData.width; x++) {
                for (var y = 0; y < canvasData.height; y++) {
                    //                      Index of the pixel in the array
                    var idx = (x + y * canvasData.width) * 4;
                    var r = canvasData.data[idx + 0];
                    var g = canvasData.data[idx + 1];
                    var b = canvasData.data[idx + 2];
                    //                      灰度的计算
                    var gray = .299 * r + .587 * g + .114 * b;
                    //                      assign gray scale value
                    canvasData.data[idx + 0] = gray; // Red channel
                    canvasData.data[idx + 1] = gray; // Green channel
                    canvasData.data[idx + 2] = gray; // Blue channel
                    // canvasData.data[idx + 3] = 255; // Alpha channel
                    // 新增黑色边框
                    // if (x < 8 || y < 8 || x > (canvasData.width - 8) || y > (canvasData.height - 8)) {
                    // canvasData.data[idx + 0] = 0;
                    // canvasData.data[idx + 1] = 0;
                    // canvasData.data[idx + 2] = 0;
                    // }
                }
            }
            context.putImageData(canvasData, 0, 0); // 处理完成的数据重新载入到canvas二维对象中

            var tempTexture = new cc.Texture2D();
            tempTexture.initWithElement(canvas);
            tempTexture.handleLoadedTexture();

            return new cc.Sprite(tempTexture);
        } 
    } 

    // 使用shader方式实现图片变灰（适用于app和浏览器不支持canvas的情况）
    if(!cc.GLProgram.createWithByteArrays){
        cc.GLProgram.createWithByteArrays = function(vert, frag){
            var shader = new cc.GLProgram();  
            shader.initWithVertexShaderByteArray(vert, frag); 
            shader.link();  
            shader.updateUniforms();
            setTimeout(function(){
                shader.link();  
                shader.updateUniforms();                
            }, 0);
            return shader;
        }
    }

    var SHADER_POSITION_GRAY_FRAG = 
        "varying vec4 v_fragmentColor;\n"+  
        "varying vec2 v_texCoord;\n"+    
        (isHtml5? "uniform sampler2D CC_Texture0;\n":"")+
        "void main()\n"+         
        "{\n"+
        "    vec4 v_orColor = v_fragmentColor * texture2D(CC_Texture0, v_texCoord);\n"+
        "    float gray = dot(v_orColor.rgb, vec3(0.299, 0.587, 0.114));\n"+
        "    gl_FragColor = vec4(gray, gray, gray, v_orColor.a);\n"+
        "}\n";

    var SHADER_POSITION_GRAY_VERT = 
        "attribute vec4 a_position;\n"+
        "attribute vec2 a_texCoord;\n"+
        "attribute vec4 a_color;\n"+
        "\n"+
        "varying vec4 v_fragmentColor;\n"+
        "varying vec2 v_texCoord;\n"+
        "\n"+                               
        "void main()\n"+
        "{\n"+                           
        "gl_Position = "+ (isHtml5?"(CC_PMatrix * CC_MVMatrix)":"CC_PMatrix") + " * a_position;\n"+
        "v_fragmentColor = a_color;\n"+
        "v_texCoord = a_texCoord;\n"+
        "}";

    var sprite = new cc.Sprite(texture);
    var shader = cc.GLProgram.createWithByteArrays(SHADER_POSITION_GRAY_VERT, SHADER_POSITION_GRAY_FRAG);
    shader.addAttribute(cc.ATTRIBUTE_NAME_POSITION, cc.VERTEX_ATTRIB_POSITION);  
    shader.addAttribute(cc.ATTRIBUTE_NAME_COLOR, cc.VERTEX_ATTRIB_COLOR);  
    shader.addAttribute(cc.ATTRIBUTE_NAME_TEX_COORD, cc.VERTEX_ATTRIB_TEX_COORDS);                
    sprite.setShaderProgram(shader);
    return sprite;
};

display.newButton = function(normalImage, selectedImage, enable, x, y, pushDown, pushUp){
    var button = new ccui.Button();
    button.setTouchEnabled(enable);
    button.loadTextures(normalImage, selectedImage, "");
    button.x = x;
    button.y = y;
    touchEvent = function (sender, type) {
        switch (type) {
        case ccui.Widget.TOUCH_BEGAN:
        // cc.audioEngine.playEffect("res/music/button.mp3", false);
            button.setScale(1.2);
            pushDown();
            break;
        case ccui.Widget.TOUCH_MOVED:
            button.setScale(1);
            break;
        case ccui.Widget.TOUCH_ENDED:
            button.setScale(1);
            pushUp();
            break;
        case ccui.Widget.TOUCH_CANCELED:
            break;
        default:
            break;
        }
    }
    button.addTouchEventListener(touchEvent, this);
    return button;
};

display.newEditBox = function(w,h,normalImage,selectedImage,defaultValue,isPassword,x,y,color1,color2,color3){
    var editBox = new cc.EditBox(cc.size(w, h),new cc.Scale9Sprite(normalImage), new cc.Scale9Sprite(selectedImage));
    editBox.setString(defaultValue);
    editBox.x = x;
    editBox.y = y;
    editBox.setFontColor(cc.color(color1, color2, color3));
    if(isPassword === true){
        editBox.setInputFlag(cc.EDITBOX_INPUT_FLAG_PASSWORD);
    }
    return editBox;
};



// 骨骼动画
display.newBone = function(path1,path2){
    ccs.armatureDataManager.addArmatureFileInfo(path1);
    var animation = ccs.Armature.create(path2);
    //animation.getAnimation().play(path3);
    // animation.setPosition(x, y);
    return animation;
};

display.newBar = function(barPicture, barName, x, y, percent){
    var loadingBar = new ccui.LoadingBar();
    loadingBar.setName(barName);
    loadingBar.loadTexture(barPicture);
    loadingBar.setPercent(percent);
    loadingBar.x = x;
    loadingBar.y = y;
    return loadingBar;
}

/**
* 帧动画
* @param layer - 父系节点
* @param iconName - icon名称
* @param count - 总帧数
* @param cishu - 播放次数
* @param speed - 播放速度
* @param x - x
* @param y - y
* @param scale - 缩放
* @param rotation - 旋转方向
* @param type - 播放完后是否 -1 隐藏或 0 删除
* @param callback - 回调函数
*/
display.newAnimation = function(layer, iconName, count, cishu, speed, x, y, scale, rotation, type, callback){
    //cc.spriteFrameCache.addSpriteFrames(plistPath);
    //spriteSheet是不需要加载任何精灵的
    var spriteSheet = cc.Sprite.create();
    spriteSheet.attr({
        x: x,
        y: y,
        scale: scale,
        rotation: rotation
    });
    layer.addChild(spriteSheet, 3);
    //allMyZidan.push(spriteSheet);
    var arr = [];
    for(var i = 1; i < count+1; i++){
        var str = iconName + i + ".png";
        var frame = cc.spriteFrameCache.getSpriteFrame(str);
        arr.push(frame);
    }
    //delay为每帧的间隔，loops为循环的次数。而下面的repeat(1)为动作的次数，即总次数为loops与repaet的乘积
    //var animation = cc.Animation.create(frames, delay, loops); 
    var animation = cc.Animation.create(arr, speed, 1); 
    var animate = cc.Animate.create(animation); 
    if(cishu === 0){
        spriteSheet.runAction(animate.repeatForever());  
    }
    else{
        spriteSheet.runAction(
            cc.sequence(
                animate.repeat(cishu),
                cc.callFunc(function(){
                    if(type === -1){ //隐藏
                        spriteSheet.setVisible(false);
                    }
                    else if(type === 0){ //删除
                        spriteSheet.removeFromParent(true);
                    }
                    else{
                        spriteSheet.setSpriteFrame(cc.spriteFrameCache.getSpriteFrame(type));
                    }
                }),
                cc.callFunc(callback)
            )
        );
    }
};

display.moveTo = function(sprite, position, speed, callback){
    var xp = 0;
    if(position.x > sprite.x){
        //图片翻转
        //sprite.setScaleX(-1*0.2);
        xp = position.x - sprite.x;
    }
    else{
        //图片面对还原
        //sprite.setScaleX(1*0.2);
        xp = sprite.x - position.x;
    }
    var yp = position.y - sprite.y;
    if(yp < 0){
        yp = -yp;
    }
    //不能使用xp^2
    var time = (Math.sqrt(xp*xp + yp*yp))/speed;
    
    var moveaction = cc.MoveTo.create(time,position);
    //到达目的地后需要回调,因此需要sequence
    
    sprite.runAction(
        cc.sequence(
            cc.MoveTo.create(time,position),
            cc.callFunc(callback)
        )
    );
};




display.createFrame = function(plistPath, iconPath, iconName, count, x, y, scale, rotation){
    var spriteSheet = cc.Sprite.create();
	spriteSheet.setPosition(x, y);  //设置坐标
	spriteSheet.isScale = scale;   //这行没用
	spriteSheet.setScale(scale)    //设置大小（0-1之间）
	spriteSheet.rotation = rotation;  //旋转角度
	cc.spriteFrameCache.addSpriteFrames(plistPath);   //加载plistPath文件里的所有纹理到内存中
	//spriteSheet是不需要加载任何精灵的
	var arr = [];
	for(var i = 1; i < count+1; i++){    //将每个纹理对象添加到数组中
		var str = iconName + i + ".png";
		var frame = cc.spriteFrameCache.getSpriteFrame(str);
		arr.push(frame);
	}
	
	//运行createFrame得到一个数组，而不是一个对象，你后面addChild()明显错了，
	//你图层中要添加的是spriteSheet,图层中怎么可能添加数组。这个方法只是把纹理加载到内存中，
	//并且用一个数组按顺序存下了所有纹理，并没有运行这个帧动画。运行帧动画是另一个方法
	return [spriteSheet, arr];   
}

display.createZhen = function(spriteSheet, arr, cishu, speed, type, callback, obj){
	//delay为每帧的间隔，loops为循环的次数。而下面的repeat(1)为动作的次数，即总次数为loops与repaet的乘积
	//var animation = cc.Animation.create(frames, delay, loops); 
	var animation = cc.Animation.create(arr, speed, 1); 
	var animate = cc.Animate.create(animation); 

	if(cishu === 0){
		spriteSheet.runAction(animate.repeatForever());  
	}
	else{
		spriteSheet.runAction(
			cc.sequence(
				animate.repeat(cishu),
				cc.callFunc(function(){
					if(type === -1){ //隐藏，用于帧动画作为子弹，若提前删除就必须从子弹数组里删除
						spriteSheet.setVisible(false);
					}
					else if(type === 0){ //删除
						spriteSheet.removeFromParent(true);
					}
					else{
						//spriteSheet.setSpriteFrame(cc.spriteFrameCache.getSpriteFrame(type));
					}}
				),
				cc.callFunc(function(){callback(obj)})
			)
		);
	}	
}


display.createZhenNoPlist = function(layer, iconPathArr, cishu, speed, x, y, scale, rotation, callback){
	var spriteSheet = cc.Sprite.create();
	spriteSheet.setPosition(x, y);
	spriteSheet.scale = scale;
	layer.addChild(spriteSheet, 300);

	var arr = [];
	for(var i = 0; i < iconPathArr.length; i++){
		var frame = new cc.Sprite(iconPathArr[i]).getSpriteFrame(); //有plist是从plist里面获取,没有则直接创建frame
		arr.push(frame);
	}

	var animation = cc.Animation.create(arr, speed, 1); 
	var animate = cc.Animate.create(animation); 
	if(cishu === 0){
		spriteSheet.runAction(animate.repeatForever());  
	}
	else{   
		spriteSheet.runAction(
			cc.sequence(
				animate.repeat(cishu),
				cc.callFunc(function(){spriteSheet.removeFromParent(true);}),
				cc.callFunc(callback)
			)
		);
	}	
}

display.createText = function(text, size, x, y, type){
    var text = new cc.LabelTTF(text, type, size, 0, 0);
	text.x = x;
	text.y = y;
	return text;
}

//过度动画
display.createCloud = function(self){
    var cloud = display.newSprite(resObj["common"].cloud1, -1000, 360)
        .addTo(self, 201);
    cloud.startX = cloud.x;
    cloud.startY = cloud.y;

    var cloud2 = display.newSprite(resObj["common"].cloud2, 1080 + 1000, 500 + 800)
        .addTo(self, 202);
    cloud2.startX = cloud2.x;
    cloud2.startY = cloud2.y;
    cloud2.setScale(0.7);

    var cloud3 = display.newSprite(resObj["common"].cloud2, 1080 + 1000, 240 - 800)
        .addTo(self, 201);
    cloud3.setFlippedY(-1)
    cloud3.setScale(0.7);

    cloud3.startX = cloud3.x;
    cloud3.startY = cloud3.y;

    var cloudFun = function(cloud, x, y){
        cloud.runAction(cc.sequence(
            cc.spawn(
                cc.scaleTo(1, 1),
                cc.moveTo(1, cc.p(x, y))
            ),
            cc.delayTime(0.5),
            cc.spawn(
                cc.moveTo(1, cc.p(cloud.startX, cloud.startY))
            ),
            cc.callFunc(function(){
                cloud.removeFromParent(true);
            })
        ))
    }

    cloudFun(cloud, 350, 360)
    cloudFun(cloud2, 890, 500)
    cloudFun(cloud3, 890, 240)
}



//-------------------------------------------------------
//-------------- node --------------

//------------------------------
//在当前结点中加入一个子结点
//@function [parent=#Node] add
//@param node child 要加入的结点
//@param number zorder 要加入结点的Z值
//@param number tag 要加入结点的tag
//@return Node#Node  当前结点
cc.Node.prototype.add = function(child, zorder, tag){
    this.addChild(child, zorder || child.getLocalZOrder(), tag || child.getTag());
    return this;
};

//------------------------------
// 把当前结点作为一个子结点加到target中
// @function [parent=#Node] addTo
// @param node target 想作为其子结点的结点
// @param number zorder 当前结点的Z值
// @param number tag 当前结点的tag
// @return Node#Node  当前结点
cc.Node.prototype.addTo = function(target, zorder, tag){
    target.addChild(this, zorder || this.getLocalZOrder(), tag || this.getTag());
    return this;
};

cc.Node.prototype.align = function(anchorPoint, x, y){
    this.setAnchorPoint(display.ANCHOR_POINTS[anchorPoint]);
    if(utils.isNumber(x) && utils.isNumber(y)){
        this.setPosition(x, y);
    }
    return this;
};

cc.Node.prototype.show = function(){
    this.setVisible(true);
    return this;
};

cc.Node.prototype.hide = function(){
    this.setVisible(false);
    return this;
};

cc.Node.prototype.pos = function(x,y){
    this.setPosition(x, y);
    return this;
};

cc.Node.prototype.size = function(width, height){
    this.setContentSize(cc.size(width, height));
    return this;
};

cc.Node.prototype._scale = cc.Node.prototype.setScale;
cc.Node.prototype.setScale = function(s){
    this._scale(s);
    return this;
};

// cc.Node.prototype._rotation = cc.Node.prototype.setRotation;
// cc.Node.prototype.setRotation = function(r){
//     this.rotation = r;
//     return this;
// };

// cc.Node.prototype._opacity = cc.Node.prototype.setOpacity;
cc.Node.prototype.opa = function(o){
    this.setOpacity(o);
    return this;
};

cc.Node.prototype.removeSelf = function(cleanup){
    this.removeFromParent(cleanup);
    return this;
};

cc.Node.prototype.zorder = function(z){
    this.setLocalZOrder(z);
    return this;
};

cc.Node.prototype.stop = function(){
    this.stopAllActions();
    return this;
};

cc.Node.prototype.fadeIn = function(time){
    this.runAction(cc.FadeIn.create(time));
    return this;
};

cc.Node.prototype.fadeOut = function(time){
    this.runAction(cc.FadeOut.create(time));
    return this;
};

cc.Node.prototype.fadeTo = function(time, opacity){
    this.runAction(cc.FadeTo.create(time, opacity));
    return this;
};

cc.Node.prototype.moveTo = function(time, x, y){
    this.runAction(cc.MoveTo.create(time, cc.p(x, y)));
    return this;
};

cc.Node.prototype.moveBy = function(time, x, y){
    this.runAction(cc.MoveBy.create(time, cc.p(x, y)));
    return this;
};

cc.Node.prototype.rotateTo = function(time, rotation){
    this.runAction(cc.RotateTo.create(time, rotation));
    return this;
};

cc.Node.prototype.rotateBy = function(time, rotation){
    this.runAction(cc.RotateBy.create(time, rotation));
    return this;
};

cc.Node.prototype.scaleTo = function(time, scale){
    this.runAction(cc.ScaleTo.create(time, scale));
    return this;
};

cc.Node.prototype.scaleBy = function(time, scale){
    this.runAction(cc.ScaleBy.create(time, scale));
    return this;
};

cc.Node.prototype.skewTo = function(time, sx, sy){
    this.runAction(cc.SkewTo.create(time, sx || this.getSkewX(), sy || this.getSkewY()));
    return this;
};

cc.Node.prototype.skewBy = function(time, sx, sy){
    this.runAction(cc.SkewBy.create(time, sx || 0, sy || 0));
    return this;
};

cc.Node.prototype.tintTo = function(time, r, g, b){
    this.runAction(cc.TintTo.create(time,  r || 0, g || 0, b || 0));
    return this;
};

cc.Node.prototype.tintBy = function(time, r, g, b){
    this.runAction(cc.TintBy.create(time,  r || 0, g || 0, b || 0));
    return this;
};

cc.Node.prototype.setX = function(__x){
    this.setPositionX(__x);
    return this;
};

cc.Node.prototype.setY = function(__y){
    this.setPositionY(__y);
    return this;
};

cc.Node.prototype.setZ = function(__z){
    this.setLocalZOrder(__z);
    return this;
};

cc.Node.prototype.getPos = function(){
    return { x:this.getPositionX(), y:this.getPositionY() };
};

cc.Node.prototype.getX = function(){
    return this.getPositionX();
};

cc.Node.prototype.getY = function(){
    return this.getPositionY();
};

cc.Node.prototype.getZ = function(){
    return this.getLocalZOrder();
};

cc.Node.prototype.getW = function(){
    return this.getContentSize().width;
};

cc.Node.prototype.getH = function(){
    return this.getContentSize().height;
};

cc.Node.prototype.setBox = function(width, height){
    this.setContentSize(cc.size(width, height));
    return this;
};

cc.Node.prototype.getBox = function(){
    return this.getContentSize();
};

cc.Node.prototype.performWithDelay = function(callback, delay){
    this.runAction(cc.sequence(
        cc.delayTime(delay),
        cc.callFunc(callback)
    ));
};

cc.Node.prototype.onTouch = function(__handler, __touchBeganHandler){
    var listener1 = cc.EventListener.create({
        event: cc.EventListener.TOUCH_ONE_BY_ONE,
        swallowTouches: true,
        onTouchBegan: function (touch, event) {
            var target = event.getCurrentTarget();
            var locationInNode = target.convertToNodeSpace(touch.getLocation());
            var s = target.getContentSize();
            var rect = cc.rect(-30, -30, s.width + 60, s.height + 60);

            if (cc.rectContainsPoint(rect, locationInNode)) {
                if(__touchBeganHandler){
                    __touchBeganHandler(touch, event)
                }
                return true;
            }
            return false;
        },
        onTouchMoved: function (touch, event) {
        },
        onTouchEnded: function (touch, event) {
            var target = event.getCurrentTarget();
            if(__handler){
                __handler(touch, event)
            }
        }
    });
    cc.eventManager.addListener(listener1, this);
    return this;
};


cc.Node.prototype.onTouch2 = function(__handler, __touchBeganHandler){
    var listener1 = cc.EventListener.create({
        event: cc.EventListener.TOUCH_ONE_BY_ONE,
        swallowTouches: true,
        onTouchBegan: function (touch, event) {
            var target = event.getCurrentTarget();
            var locationInNode = target.convertToNodeSpace(touch.getLocation());
            var s = target.getContentSize();
            var rect = cc.rect(0, 0, s.width, s.height);

            if (cc.rectContainsPoint(rect, locationInNode)) {
                if(__touchBeganHandler){
                    __touchBeganHandler(touch, event)
                }
                return true;
            }
            return false;
        },
        onTouchMoved: function (touch, event) {
        },
        onTouchEnded: function (touch, event) {
            var target = event.getCurrentTarget();
            if(__handler){
                __handler(touch, event)
            }
        }
    });
    cc.eventManager.addListener(listener1, this);
    return this;
};

cc.Node.prototype.playEffect = function(snd, func, loop){
    if(this.__soundId__){
        sound.stopEffect(this.__soundId__);
    }
    this.__soundId__ = sound.playEffect(snd, loop);
    if(func){
        this.performWithDelay(function(){
            func();
        }, snd[1] + 0.5);
    }
    return this;
};

cc.Node.prototype.stopEffect = function(){
    if(this.__soundId__){
        sound.stopEffect(this.__soundId__);
    }
    return this;
};

//-------------- sprite --------------

//------------------------------
// 在X方向上翻转当前精灵
// @function [parent=#Sprite] flipX
// @param boolean b 是否翻转
// @return Sprite#Sprite  当前精灵
cc.Sprite.prototype.flipX = function(b){
    this.setFlippedX(b);
    return this;
};

//------------------------------
// 在Y方向上翻转当前精灵
// @function [parent=#Sprite] flipY
// @param boolean b 是否翻转
// @return Sprite#Sprite  当前精灵
cc.Sprite.prototype.flipY = function(b){
    this.setFlippedY(b);
    return this;
};



//---------------------------------------------------------------

var utils = {
    isNumber:function(obj){
        return obj === +obj;
    },

    isString: function(obj){
        return obj === obj+'';
    },

    isBoolean:function(obj){
        return obj === !!obj;
    },

	isInteger:function(obj){
        return (obj | 0) === obj;
    },


    /*
     * 已知一个点的坐标，到另一个点的距离和角度求另外一个坐标
     * 这段代码是转换为适合cocos2d直接使用的，以正上方为0度，正数为顺时针方向
     * pointB——点A
     * angle——角度
     * bevel——距离
     */
    getNewPoint:function(point, angle, bevel){
        angle = angle * -1 + 90;
        var radian = angle * Math.PI / 180;
        var xMargin = Math.cos(radian) * bevel;
        var yMargin = Math.sin(radian) * bevel;
        return cc.p(point.x + xMargin,point.y + yMargin);
    },

    /*
     * 已知两个点的坐标，求一个点相对于另一个点的角度是多少
     * 若点A在点B的左边则返回角度为负数
     * 若点A在点B的右边则返回角度为正数
     * point1——点A
     * point2——点B
     */
    getAngle:function(point1, point2){
        if(cc.pDistance(point1, point2) == 0)
            return 0;

        var angle = Math.atan((point1.x-point2.x)/(point1.y-point2.y))/Math.PI*180;

        if(point1.y < point2.y){
            if(point1.x < point2.x)
                angle -= 180;
            else
                angle += 180;
        }

        return angle;
    },


    //矩形相交判断，效率低且只适合最普通的状态
    collision:function(sprite1, sprite2){
        var rect1 = sprite1.getBoundingBox();
        var rect2 = sprite2.getBoundingBox();

        var x1 = rect1.x;  var y1 = rect1.y;
        var x2 = cc.rectGetMaxX(rect1);  var y2 = cc.rectGetMaxY(rect1);

        var x3 = rect2.x;  var y3 = rect2.y;
        var x4 = cc.rectGetMaxX(rect2);  var y4 = cc.rectGetMaxY(rect2);
        if((x3<x1 && x1<x4 && y3<y1 && y1<y4) || (x3<x2 && x2<x4 && y3<y1 && y1<y4) || (x3<x1 && x1<x4 && y3<y2 && y2<y4) || (x3<x2 && x2<x4 && y3<y2 && y2<y4)){
            return true;
        }
        if((x1<x3 && x3<x2 && y1<y3 && y3<y2) || (x1<x4 && x4<x2 && y1<y3 && y3<y2) || (x1<x3 && x3<x2 && y1<y4 && y4<y2) || (x1<x4 && x4<x2 && y1<y4 && y4<y2)){
            return true;
        }
        return false;
    },

    //三角形与圆形相交判断。三角形为两个直角组成的非直角，width和height都是直角三角形的宽和长(已知两直角边和低点坐标)
    collisionSanjiao:function(width, height, point, sprite2){
        if(sprite2.x >= point.x - width && sprite2.x <= point.x+width){

            var juliX = sprite2.x - point.x;
            if(juliX < 0){
                juliX = -juliX;
            }

            var height2 = juliX*height/width;

            var y2 = point.y + (height - height2);
            if(sprite2.y >= point.y && sprite2.y <= y2){
                return true;
            }
            else{
                return false;
            }
        }
        else{
            return false;
        }
    },


    //各种碰撞
    collision2:function(sprite1, sprite2, pengzhuangType){
        if(!pengzhuangType){ //圆的碰撞，效率很高，需要读配置文件
            var ax;
            var ay;
            if(sprite1.haveFather){ //如果一个精灵有父系节点fx那么就不使用当前节点的x
                ax = sprite1.x + sprite1.getParent().x;
                ay = sprite1.y + sprite1.getParent().y;
            }
            else{
                ax = sprite1.x;
                ay = sprite1.y;
            }

            var bx;
            var by;
            if(sprite2.haveFather){
                bx = sprite2.x + sprite2.getParent().x;
                by = sprite2.y + sprite2.getParent().y;
            }
            else{
                bx = sprite2.x;
                by = sprite2.y;
            }

            var xx = (ax - bx)*(ax - bx);
            var yy = (ay - by)*(ay - by);
            var juli = Math.sqrt(xx+yy);

            var banjin1 = 50;
            if(sprite1.banjin){
                banjin1 = sprite1.banjin;
            }
            var banjin2 = 50;
            if(sprite2.banjin){
                banjin2 = sprite2.banjin;
            }


            banjin1 *= (sprite1.scale);
            banjin2 *= (sprite2.scale);

            if(banjin1 + banjin2 > juli){
                return true;
            }
            else{
                return false;
            }
        }


        else if(pengzhuangType === 1){//一般矩形碰撞，可适应世界坐标的。效率很高，由于没有getContentSize,碰撞大小只能通过配置文件读取
            var ax;//世界坐标x
            var ay;//世界坐标y
            if(sprite1.haveFather){ //如果一个精灵有父系节点fx那么就不使用当前节点的x
                ax = sprite1.x + sprite1.getParent().x;
                ay = sprite1.y + sprite1.getParent().y;
            }
            else{
                ax = sprite1.x;
                ay = sprite1.y;
            }

            var bx;
            var by;
            if(sprite2.haveFather){
                bx = sprite2.x + sprite2.getParent().x;
                by = sprite2.y + sprite2.getParent().y;
            }
            else{
                bx = sprite2.x;
                by = sprite2.y;
            }

            var w1 = 50;
            var h1 = 50;
            var w2 = 50;
            var h2 = 50;

            var x1 = ax - w1*(sprite1.scale);
            var y1 = ay - h1*(sprite1.scale);
            var x2 = ax + w1*(sprite1.scale);
            var y2 = ay + h1*(sprite1.scale);

            var x3 = bx - w2*(sprite2.scale);
            var y3 = by - h2*(sprite2.scale);
            var x4 = bx + w2*(sprite2.scale);
            var y4 = by + h2*(sprite2.scale);

            if((x3<x1 && x1<x4 && y3<y1 && y1<y4) || (x3<x2 && x2<x4 && y3<y1 && y1<y4) || (x3<x1 && x1<x4 && y3<y2 && y2<y4) || (x3<x2 && x2<x4 && y3<y2 && y2<y4)){
                return true;
            }
            if((x1<x3 && x3<x2 && y1<y3 && y3<y2) || (x1<x4 && x4<x2 && y1<y3 && y3<y2) || (x1<x3 && x3<x2 && y1<y4 && y4<y2) || (x1<x4 && x4<x2 && y1<y4 && y4<y2)){
                return true;
            }
            return false;

        }
        else if(pengzhuangType === 2){//通过contentSize判断矩形相交，适用于任何情况，效率低。并且可适应世界坐标的，使用了contentSize。
            var ax;//世界坐标x
            var ay;//世界坐标y
            if(sprite1.haveFather){ //如果一个精灵有父系节点fx那么就不使用当前节点的x
                ax = sprite1.x + sprite1.getParent().x;
                ay = sprite1.y + sprite1.getParent().y;
            }
            else{
                ax = sprite1.x;
                ay = sprite1.y;
            }

            var bx;
            var by;
            if(sprite2.haveFather){
                bx = sprite2.x + sprite2.getParent().x;
                by = sprite2.y + sprite2.getParent().y;
            }
            else{
                bx = sprite2.x;
                by = sprite2.y;
            }
            bx = sprite2.x;
            by = sprite2.y;

            var content1 = sprite1.getContentSize();
            var content2 = sprite2.getContentSize();

            var w1 = content1.width/2;
            var h1 = content1.height/2;

            var w2 = content2.width/2;
            var h2 = content2.height/2;

            var x1 = ax - w1*(sprite1.scale);
            var y1 = ay - h1*(sprite1.scale) + (0.5 - sprite1.getAnchorPoint().y)*(h1*2)*(sprite1.scale);
            var x2 = ax + w1*(sprite1.scale);
            var y2 = ay + h1*(sprite1.scale) + (0.5 - sprite1.getAnchorPoint().y)*(h1*2)*(sprite1.scale);

            var x3 = bx - w2*(sprite2.scale);
            var y3 = by - h2*(sprite2.scale) + (0.5 - sprite2.getAnchorPoint().y)*(h2*2)*(sprite2.scale);
            var x4 = bx + w2*(sprite2.scale);
            var y4 = by + h2*(sprite2.scale) + (0.5 - sprite2.getAnchorPoint().y)*(h2*2)*(sprite2.scale);


            if((x3<x1 && x1<x4 && y3<y1 && y1<y4) || (x3<x2 && x2<x4 && y3<y1 && y1<y4) || (x3<x1 && x1<x4 && y3<y2 && y2<y4) || (x3<x2 && x2<x4 && y3<y2 && y2<y4)){
                return true;
            }
            if((x1<x3 && x3<x2 && y1<y3 && y3<y2) || (x1<x4 && x4<x2 && y1<y3 && y3<y2) || (x1<x3 && x3<x2 && y1<y4 && y4<y2) || (x1<x4 && x4<x2 && y1<y4 && y4<y2)){
                return true;
            }
            return false;
        }
        else if(pengzhuangType === 3){//用于空中支援必杀
            if(collisionSanjiao(64, 234, {x:360, y:sprite1.y+45}, sprite2)){
                return true;
            }
            else{
                return collisionSanjiao(280, 100, {x:360, y:sprite1.y-25}, sprite2);
            }
        }
        else{
            //适用于圆的任何碰撞，使用了getContentSize效率低要求精度高的碰撞，例如大爆炸。圆形检测碰撞,要注意的是getContentSize()
            //方法时，不管精灵是放大的还是缩小的全都按原来的大小获取width和height。而getBoundingBox()是获取当前大小
            var ax;
            var ay;
            if(sprite1.haveFather){ //如果一个精灵有父系节点fx那么就不使用当前节点的x
                ax = sprite1.x + sprite1.getParent().x;
                ay = sprite1.y + sprite1.getParent().y;
            }
            else{
                ax = sprite1.x;
                ay = sprite1.y;
            }

            var bx;
            var by;
            if(sprite2.haveFather){
                bx = sprite2.x + sprite2.getParent().x;
                by = sprite2.y + sprite2.getParent().y;
            }
            else{
                bx = sprite2.x;
                by = sprite2.y;
            }

            var xx = (ax - bx)*(ax - bx);
            var yy = (ay - by)*(ay - by);
            var juli = Math.sqrt(xx+yy);

            var content1 = sprite1.getContentSize();
            var content2 = sprite2.getContentSize();

            var banjin1;
            var banjin2;
            if(content1.width - content1.height >= 0){
                banjin1 = content1.height/2;
            }
            else{
                banjin1 = content1.width/2;
            }
            banjin1 *= (sprite1.scale);
            if(content2.width - content2.height >= 0){
                banjin2 = content2.height/2;
            }
            else{
                banjin2 = content2.width/2;
            }
            banjin2 *= (sprite2.scale);
            if(banjin1 + banjin2 > juli){
                return true;
            }
            else{
                return false;
            }
        }
    },

    //获取底点坐标
    getEndPoint:function(sprite){
        var rect1 = sprite.getBoundingBox();
        var x1 = rect1.x;  var y1 = rect1.y;
        var x2 = cc.rectGetMaxX(rect1);
        var endPoint = {};
        endPoint.x = (x1 + x2)/2;
        endPoint.y = y1;
        return endPoint;
    },

    // getAngle:function (px1, py1, px2, py2) {
    //     var diff_x = px2 - px1,
    //         diff_y = py2 - py1;
    //     //返回角度,不是弧度
    //     return 360*Math.atan(diff_y/diff_x)/(2*Math.PI);
    // },

    //更新监听器
    updateListener:function(mc, isOk){
        if(isOk){
            cc.eventManager.resumeTarget(mc, true);
        }else{
            cc.eventManager.pauseTarget(mc, true);
        }
    },

    initClickListener:function(mc, func){

        var touchListener = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function(touch, event){
                var target = event.getCurrentTarget();
                var locationInNode = target.convertToNodeSpace(touch.getLocation());
                var s = target.getContentSize();
                var rect = cc.rect(0, 0, s.width, s.height);
                if (cc.rectContainsPoint(rect, locationInNode)) {
                    return true;
                }
                return false;
            },
            onTouchEnded:function(touch, event){
                func(mc);
            }
        });
        mc.touchMoveListener = touchListener;
        cc.eventManager.addListener(touchListener, mc);
    },

    initClickListener1:function(mc, func){

        var touchListener1 = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function(touch, event){
                var target = event.getCurrentTarget();
                var locationInNode = target.convertToNodeSpace(touch.getLocation());
                var s = target.getContentSize();
                var rect = cc.rect(0, 0, s.width, s.height);
                if (cc.rectContainsPoint(rect, locationInNode)) {
                    return true;
                }
                return false;
            },
            onTouchEnded:function(touch, event){
                func(mc);
            }
        });
        mc.touchMoveListener = touchListener1;
        // cc.eventManager.addListener(touchListener1, mc);
        return touchListener1;
    },
	
	initClickListener2:function(mc, func){

        var touchListener2 = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function(touch, event){
                var target = event.getCurrentTarget();
                var locationInNode = target.convertToNodeSpace(touch.getLocation());
                var s = target.getContentSize();
                var rect = cc.rect(-20, -20, s.width + 40, s.height + 40);
                if (cc.rectContainsPoint(rect, locationInNode)) {
                    return true;
                }
                return false;
            },
            onTouchEnded:function(touch, event){
                func(mc);
            }
        });
        mc.touchMoveListener = touchListener2;
        cc.eventManager.addListener(touchListener2, mc);
        return touchListener2;
    },


    //随机数组
    mixArray:function(array){

        var i;
        for(i = 0;i<3;i++){
            var ran = Math.round(Math.random()*(array.length - 1));   //获得数组index随机数
            var n = array.splice(ran,1);
            array = array.concat(n);
        }
        return array;
    },

    //随机数组
    mixArrayAll:function(array){

        var i;
        for(i = 0;i<array.length;i++){
            var ran = Math.round(Math.random()*(array.length - 1));   //获得数组index随机数
            var n = array.splice(ran,1);
            array = array.concat(n);
        }
        return array;
    },
		
	random:function(min, max){
        min = min || 0;
        max = max || 1;
        if(!Math.seed) Math.seed = 5;

        Math.seed = (Math.seed * 9301 + 49297) % 233280;
        var rnd = Math.seed / 233280.0;
        return min + rnd * (max - min);
        // return parseInt(min + Math.random()*max);
    },

    // utils.randomInt(0, 10) 随机出来的数据是 0~9
    randomInt:function(min, max){
        return parseInt(utils.random(min, max));
    },

    //随机取得数组中的一个
    // @param exclude 排除的数组[坐标]
    randomArrayOne:function(array, exclude){
        var n = Math.floor(Math.random() * array.length);
        if(utils.isNumber(exclude) && exclude == n){
            return utils.randomArrayOne(array, exclude);
        }
        return array[n];
    },

    //随机取得数组中的一个
    // @param exclude 排除的数组[值]
    randomArrayOneVal:function(array, exclude){
        var n = Math.floor(Math.random() * array.length);
        if(exclude == array[n]){
            return utils.randomArrayOneVal(array, exclude);
        }
        return array[n];
    },

    // 随机排序整个数组
    randomArray:function(array){
        return array.slice(0).sort(
            function(){
                return Math.random()>0.5?-1:1;
            }
        );
    },

    // 数组洗牌
    arrayShuffle:function(originalArray){
        var arr = originalArray.slice(0);
        for(var i = 0, len = arr.length; i < len; i++)
        {
            var rand = parseInt(Math.random() * len);
            var temp = arr[rand];
            arr[rand] = arr[i];
            arr[i] = temp;
        }
        return arr;
    },

    // 数组洗牌2
    arrayShuffle2:function(originalArray){
        var arr = originalArray.slice(0);
        var mixedArray = [];
        while(arr.length > 0){
            //generate a random index of the original array
            var rand = parseInt(Math.random() * arr.length);
            //push the random element into the mixed one, at the same time, delete the original element
            mixedArray.push(arr[rand]);
            arr.splice(rand, 1);
        }
        return mixedArray;

        // var arr = [1,2,3,4]
        // var res = [];
        // for (var i = 0, len = arr.length; i < len; i++) {
        //   var j = Math.floor(Math.random() * arr.length);
        //   res[i] = arr[j];
        //   arr.splice(j, 1);
        // }
        // console.log(res);
    },

    // 合并数组 b 合并到 a
    mergeArray:function(a, b){
        var arr = a.slice(0);
        arr.push.apply(arr, b);
        return arr;

        // var a = [ 1, 2, 3, 4, 5, 6, 7, 8, 9 ];
        // var b = [ "foo", "bar", "baz", "bam", "bun", "fun" ];
        // `b` onto `a`:
        // a.push.apply( a, b );
        // a; // [1,2,3,4,5,6,7,8,9,"foo","bar","baz","bam","bun","fun"]
        // // or `a` into `b`:
        // b.unshift.apply( b, a );
        // b; // [1,2,3,4,5,6,7,8,9,"foo","bar","baz","bam","bun","fun"]
    },

    // 克隆数组
    cloneArray:function(array){
        return array.slice(0);
    },

    clone:function(obj) {
        if (null == obj || "object" != typeof obj) return obj;

        // Handle Date
        if (obj instanceof Date) {
            var copy = new Date();
            copy.setTime(obj.getTime());
            return copy;
        }

        // Handle Array
        if (obj instanceof Array) {
            var copy = [];
            for (var i = 0;i < obj.length; ++i){
                copy[i] = utils.clone(obj[i]);
            }
            return copy;
        }

        // Handle Object
        if (obj instanceof Object) {
            var copy = {};
            for (var attr in obj) {
                if (obj.hasOwnProperty(attr)) copy[attr] = utils.clone(obj[attr]);
            }
            return copy;
        }
        throw new Error("Unable to copy obj! Its type isn't supported.");
    },

    objectCompare:function(x, y){
        // If both x and y are null or undefined and exactly the same 
        if ( x === y ){
            return true;
        }
        // If they are not strictly equal, they both need to be Objects 
        if ( ! ( x instanceof Object ) || ! ( y instanceof Object ) ){
            return false;
        }
        //They must have the exact same prototype chain,the closest we can do is
        //test the constructor. 
        if ( x.constructor !== y.constructor ){
            return false;
        }
        for ( var p in x ){
            //Inherited properties were tested using x.constructor === y.constructor
            if ( x.hasOwnProperty( p ) ){
                // Allows comparing x[ p ] and y[ p ] when set to undefined 
                if ( ! y.hasOwnProperty( p ) ) { return false; }
                // If they have the same strict value or identity then they are equal 
                if ( x[ p ] === y[ p ] ) { continue; }
                // Numbers, Strings, Functions, Booleans must be strictly equal 
                if ( typeof( x[ p ] ) !== "object" ) { return false; }
                // Objects and Arrays must be tested recursively 
                if ( ! Object.equals( x[ p ], y[ p ] ) ) { return false; }
             }
        }
        for ( p in y ){
            // allows x[ p ] to be set to undefined
            if ( y.hasOwnProperty( p ) && ! x.hasOwnProperty( p ) ) { return false; }
        }
        return true;
    },

    // 通过两点的坐标, 返回角度
    angle:function(start,end){
        var diff_x = end.x - start.x,
            diff_y = end.y - start.y;
        //返回角度,不是弧度
        return 360*Math.atan(diff_y/diff_x)/(2*Math.PI);
    },

    // 通过两点的坐标, 返回距离
    distance:function(start,end){
        var xdiff = end.x - start.x;
        var ydiff = end.y - start.y;
        return Math.pow((xdiff * xdiff + ydiff * ydiff), 0.5);
    },

    // 是否碰撞
    iscollision:function(node1, node2){
        // var rect1 = node1.boundingBox();
        // var rect2 = node2.boundingBox();

        // var left1 = cc.rectGetMinX(rect1);
        // var right1 = cc.rectGetMaxX(rect1);
        // var top1 = cc.rectGetMinY(rect1);
        // var bottom1 = cc.rectGetMaxY(rect1);
        
        // var left2 = cc.rectGetMinX(rect2)+5;
        // var right2 = cc.rectGetMaxX(rect2)-5;
        // var top2 = cc.rectGetMinY(rect2)+8;
        // var bottom2 = cc.rectGetMaxY(rect2)-8;
        
        // if ( left1>right2 || top1>bottom2)
        //     return false;
        // if ( left2>right1 || top2>bottom1 )
        //     return false;
        // return true;

        var rect = node2.boundingBox();
        //判断矩形碰撞
        if (rect.containsPoint(node1.getPosition())){
            return true;
        }
        return false;
    },

    //去掉链接字符串某个参数
    funcUrlDel:function(loca, name){
        // var loca = window.location;
        var baseUrl = loca.split("?")[0] + "?";
        var query = loca.split("?")[1];

        if(query && query.indexOf(name)>-1){
            var obj = {};
            var arr = query.split("&");
            for (var i = 0; i < arr.length; i++) {
                arr[i] = arr[i].split("=");
                obj[arr[i][0]] = arr[i][1];
            };
            delete obj[name];
            var url = baseUrl + JSON.stringify(obj).replace(/[\"\{\}]/g,"").replace(/\:/g,"=").replace(/\,/g,"&");
            return url
        }
        else{
            return baseUrl;
        }
    }
}




/*
 * 张瑜博个人工具文件
 * 张瑜博
 * 修改时间:2016.6.29
 * */

/*
 * 张瑜博个人工具文件
 * 张瑜博
 * 修改时间:2016.11.15
 * */

var zybTools = {
	//UI坐标与游戏坐标的转换
    uiPos:function(x, y){
        return cc.p(x, cc.winSize.height-y);
    },

    //直接封装ccui的按钮
    //buttonType用于使用缓存时的类型设置, ccui.Widget.PLIST_TEXTURE
    createButton:function(texName, callBack, buttonType){
        var button = new ccui.Button();
        button.loadTextures(texName, texName, "", buttonType);
        button.addClickEventListener(function(sender){
            callBack && callBack(sender);
        });

        return button;
    },

    //直接封装ccui的按钮2
    //buttonType用于使用缓存时的类型设置, ccui.Widget.PLIST_TEXTURE
    createButton2:function(texName, callBack, buttonType){
        var button = new ccui.Button();
        button.loadTextures(texName, texName, "", buttonType);
        button.addTouchEventListener(function (sender, type) {
            switch (type) {
                case ccui.Widget.TOUCH_BEGAN:
                    callBack && callBack(sender);
                    break;
                case ccui.Widget.TOUCH_MOVED:
                    break;
                case ccui.Widget.TOUCH_ENDED:
                    break;
                case ccui.Widget.TOUCH_CANCELED:
                    break;
                default:
                    break;
            }
        }, this);

        return button;
    },

    //直接封装ccui的按钮3
    //buttonType用于使用缓存时的类型设置, ccui.Widget.PLIST_TEXTURE
    createButton3:function(texName, callBack1, callBack2, callBack3, buttonType){
        var button = new ccui.Button();
        button.loadTextures(texName, texName, "", buttonType);
        button.addTouchEventListener(function (sender, type) {
            switch (type) {
                case ccui.Widget.TOUCH_BEGAN:
                    callBack1 && callBack1(sender);
                    break;
                case ccui.Widget.TOUCH_MOVED:
                    break;
                case ccui.Widget.TOUCH_ENDED:
                    callBack2 && callBack2(sender);
                    break;
                case ccui.Widget.TOUCH_CANCELED:
                    callBack3 && callBack3(sender);
                    break;
                default:
                    break;
            }
        }, this);

        return button;
    },

    //直接封装ccui的按钮4
    //buttonType用于使用缓存时的类型设置, ccui.Widget.PLIST_TEXTURE
    createButton4:function(texName1, texName2, callBack, buttonType){
        var button = new ccui.Button();
        button.loadTextures(texName1, texName2, "", buttonType);
        button.addClickEventListener(function(sender){
            callBack && callBack(sender);
        });

        return button;
    },

    //将任意一个对象制作成按钮
    createSpriteButton:function(sprite, callBack, isSwallowTouches){
        if(isSwallowTouches === undefined)
            isSwallowTouches = true;
        sprite.enabled = true;
        sprite.isMoveCall = false;

        sprite._onTouchBegan = function(touch, event){
            var target = event.getCurrentTarget();
            var buttonRect = target.getBoundingBox();

            if(!target.isVisible()){
                return false;
            }

            if(!target.enabled){
                return false;
            }

            //判断触摸点是否在按钮上，没有则不响应
            var point = touch.getLocation();
            if(cc.rectContainsPoint(buttonRect, target.getParent().convertToNodeSpace(point))){
                target._TouchMove = false;
                target.isMoveCall = false;
                target._TouchStartPos = {x:point.x, y:point.y};
                return true;
            }
            return false;
        };
        sprite._onTouchMoved = function(touch, event){
            var target = event.getCurrentTarget();
            var point = touch.getLocation();

            var shakeValue = 15;
            if(Math.abs(point.x-target._TouchStartPos.x) > shakeValue ||
                Math.abs(point.y-target._TouchStartPos.y) > shakeValue){
                target._TouchMove = true;

                if(!target.isMoveCall){
                    target.isMoveCall = true;
                }
            }
        };
        sprite._onTouchEnded = function(touch, event){
            var target = event.getCurrentTarget();

            //回调函数
            if(target.enabled)
            {
                if(!target._TouchMove){

                    callBack && callBack(target);
                }
            }
        };

        sprite.setEnabled = function(enabled){
            sprite.enabled = enabled;
        };

        //开启单点触摸
        cc.eventManager.addListener({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: isSwallowTouches,
            onTouchBegan: sprite._onTouchBegan,
            onTouchMoved: sprite._onTouchMoved,
            onTouchEnded: sprite._onTouchEnded
        }, sprite);
    },

    //cocoStudio骨骼动画的动画播放结束回调
    ccsArmatureEndCallFunc:function(obj, callBack, self){
        obj.getAnimation().setMovementEventCallFunc(function(armature, movementType, movementID){
            if(movementType == ccs.MovementEventType.complete){
                armature.getAnimation().setMovementEventCallFunc(null);
                callBack(armature);
            }
        }, self);
    },

    //按钮的晃动
    buttonRock:function(button, callBack){
        this.leftRightRock(button, callBack);
    },
    //左右晃动动作
    leftRightRock:function(button, callBack){
        if(button.isRock)
            return ;

        var x = button.x;
        var y = button.y;
        button.isRock = true;

        var move = cc.moveBy(0.03, 10, 0);
        var move2 = cc.moveBy(0.06, -20, 0);
        var repeat = cc.repeat(cc.sequence(move2, move2.reverse()), 2);
        var call = cc.callFunc(function(obj){
            obj.setPosition(x, y);
            obj.isRock = false;

            callBack && callBack(obj);
        }, this);
        var call2 = cc.callFunc(function(obj){
            obj.runAction(cc.sequence(repeat, call));
        }, this);

        button.runAction(cc.sequence(move, call2));
    },

    //弹动出现的动作
    goodsInScene:function(node, callBack){
        if(node.isRock)
            return ;
        node.isRock = true;

        var scale = node.getScale();
        node.setScale(0.1*scale);

        var scale1 = cc.scaleTo(0.3, 1.3*scale, 1.3*scale).easing(cc.easeOut(0.3));
        var scale2 = cc.scaleTo(0.1, 0.8*scale, 0.8*scale);
        var scale3 = cc.scaleTo(0.1, 1.15*scale, 1.15*scale);
        var scale4 = cc.scaleTo(0.05, scale, scale);
        var call = cc.callFunc(function(obj){
            obj.isRock = false;
            callBack && callBack();
        }, this);

        node.runAction(cc.sequence(scale1, scale2, scale3, scale4, call));
    },

    //掉落动作
    droppedAction:function(node, dropValue, callBack){
        var time = dropValue/350;
        var move1 = cc.moveBy(0.3*time, 0, -dropValue).easing(cc.easeOut(0.3*time));
        var move2 = cc.moveBy(0.1*time, 0, 0.2*dropValue);
        var move3 = cc.moveBy(0.1*time, 0, -0.2*dropValue);
        var move4 = cc.moveBy(0.05*time, 0, 0.1*dropValue);
        var move5 = cc.moveBy(0.05*time, 0, -0.1*dropValue);
        var call = cc.callFunc(function(){
            callBack && callBack();
        });
        node.runAction(cc.sequence(move1, move2, move3, move4, move5, call));
    },

    //获取两个点之间的角度，点1在点2的哪角度
    getAngle:function(point1, point2){
        if(cc.pDistance(point1, point2) == 0)
            return 0;

        var angle = Math.atan((point1.x-point2.x)/(point1.y-point2.y))/Math.PI*180;

        if(point1.y < point2.y){
            if(point1.x < point2.x)
                angle -= 180;
            else
                angle += 180;
        }

        return angle;
    }
};




//--------------------------------------------------------------------------
var sound = {};

sound.resourceLength = 0;
sound.resourceUrls = "";

sound.dingdongSnd = "";
sound.loopSnd = "";

//  ======================== Music ========================
sound.playMusic = function(url, loop){
    cc.audioEngine.playMusic(url, loop);
};

sound.playSndDingdong = function(_self, _url){
    conn.playMathSndDingDo(_url);
};

sound.stopSndDingDong = function(){
    conn.stopMathSndDingDo();
};

// @param releaseData 是否释放内存
sound.stopMusic = function(releaseData, soundId){
    cc.audioEngine.stopMusic(releaseData);
};

sound.resumeMusic = function(){
    cc.audioEngine.resumeMusic();
};

sound.pauseMusic = function(){
    cc.audioEngine.pauseMusic();
};

//  ======================== Effect ========================

sound.playEffect = function(url, loop){
    if(url){
        if(url instanceof Array){
            return cc.audioEngine.playEffect(url[0] , 0);
        }
        else{
            return cc.audioEngine.playEffect(url , 0);
        }
    }   
};

sound.stopEffect = function(soundId){
    cc.audioEngine.stopEffect(soundId);
};

sound.stopAllEffects = function(){
    cc.audioEngine.stopAllEffects();
};

sound.stopLoopEffect = function(soundRes){
    cc.audioEngine.stopEffect(soundRes);
};


sound.pauseEffect = function(soundId){
    cc.audioEngine.pauseEffect(soundId);
};

sound.pauseAllEffects = function(){
    cc.audioEngine.pauseAllEffects();
};

sound.resumeEffect = function(soundId){
    cc.audioEngine.resumeEffect(soundId);
};

sound.resumeAllEffects = function(){
    cc.audioEngine.resumeAllEffects();
};

sound.stopAllEffectsAndMusic = function(){
    cc.audioEngine.stopAllEffects();
}

sound.setMusicVolume = function(volume){
    cc.audioEngine.setMusicVolume(volume);
};

sound.getMusicVolume = function(){
    return cc.audioEngine.getMusicVolume();
};

sound.setEffectsVolume = function(volume){
    cc.audioEngine.setEffectsVolume(volume);
};

sound.getEffectsVolume = function(){
    return cc.audioEngine.getEffectsVolume();
};
